package hungerhelper.restaurants;

import algs12.Point2D;

import java.util.Objects;

public class Restaurant {
    private final String name;
    private final Cuisine cuisine;
    private final Point2D location;

    public Restaurant(String name, Cuisine cuisine, Point2D location) {
        if(name == null || cuisine == null || location == null) {
            throw new IllegalArgumentException("Input is null");
        }
        this.name = name;
        this.cuisine = cuisine;
        this.location = location;
    }

    public String getName() {
        return name;
    }

    public Cuisine getCuisine() {
        return cuisine;
    }

    public Point2D getLocation() {
        return location;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null || getClass() != o.getClass()) return false;
        Restaurant that = (Restaurant) o;
        return Objects.equals(name, that.name) && cuisine == that.cuisine && Objects.equals(location, that.location);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, cuisine, location);
    }
}
