package hungerhelper.restaurants;

import algs12.Point2D;

import java.util.Objects;

public class RestaurantKey {
    private final String name;
    private final Point2D location;

    public RestaurantKey(String name, Point2D location) {
        if(name == null || location == null) {
            throw new IllegalArgumentException("Invalid input");
        }
        this.name = name;
        this.location = location;
    }

    public String getName() {
        return name;
    }

    public Point2D getLocation() {
        return location;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null || getClass() != o.getClass()) return false;
        RestaurantKey that = (RestaurantKey) o;
        return Objects.equals(name, that.name) && Objects.equals(location, that.location);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, location);
    }
}
