package stdlib;

import java.util.concurrent.*;

public class YExecutor {
	public static boolean timeOut = false;
	public static void run (Runnable task) {
		call (5000, "execution", Executors.callable (task));
	}
	public static void run (int timeoutInMilliseconds, Runnable task) {
		call (timeoutInMilliseconds, "execution", Executors.callable (task));
	}
	public static void run (int timeoutInMilliseconds, String nameToPrintOnTimeout, Runnable task) {
		call (timeoutInMilliseconds, nameToPrintOnTimeout, Executors.callable (task));
	}
	public static <T> T call (Callable<T> task) {
		return call (5000, "execution", task);
	}
	public static <T> T call (int timeoutInMilliseconds, Callable<T> task) {
		return call (timeoutInMilliseconds, "execution", task);
	}
	public static <T> T call (int timeoutInMilliseconds, String nameToPrintOnTimeout, Callable<T> task) {
		timeOut = false;
		ExecutorService pool = Executors.newSingleThreadExecutor();
		Future<T> future = pool.submit(task);
		try {
			//System.err.format ("  Start %s(%s):\n", name, toString (arg));
			T result = future.get(timeoutInMilliseconds, TimeUnit.MILLISECONDS);
			return result;
		} catch (TimeoutException e) {
			timeOut = true;
			System.err.format ("Timeout during %s: aborted after %.3f seconds: ", nameToPrintOnTimeout, timeoutInMilliseconds/1000.0);
			System.err.format ("%scanceled\n", future.cancel(true) ? "" : "not ");
		} catch (InterruptedException e) {
			System.err.format ("Interrupted!!!!!\n");
			e.printStackTrace ();
			future.cancel(true);
			throw new Error ("YIKES: " +  e);
		} catch (ExecutionException e) {
			Throwable ee = e.getCause ();
			if (ee instanceof Error) {
				future.cancel(true);
				throw (Error) ee;
			} else if (ee instanceof RuntimeException) {
				future.cancel(true);
				throw (RuntimeException) ee;
			} else {
				System.err.format ("Execution Exception!!!!!\n");
				e.printStackTrace ();
				future.cancel(true);
				throw new Error ("YIKES: " +  e);
			}
		} finally {
			future.cancel (true);
			pool.shutdown ();
			pool.shutdownNow ();
			// this doesn't work...
//			try {
//				if (!pool.awaitTermination(timeoutInMilliseconds, TimeUnit.MILLISECONDS)) {
//
//					System.err.format ("Thread did not stop: had to shutdown virtual machine.\n");
//					System.exit (0);
//				}
//			} catch (InterruptedException e) {
//				System.err.format ("Interrupted!!!!!\n");
//				e.printStackTrace ();
//				future.cancel(true);
//				throw new Error ("YIKES: " +  e);
//			}
		}
		return null;
	}
}
