package stdlib;

import java.util.WeakHashMap;

public class YWeakHashMap3<K1,K2,K3,V> {
	private WeakHashMap<K1,WeakHashMap<K2,WeakHashMap<K3,V>>> contents = new WeakHashMap<> ();

	public void put (K1 key1, K2 key2, K3 key3, V val) {
		getMap (getMap (this.contents, key1), key2).put (key3, val);
	}

	public V get (K1 key1, K2 key2, K3 key3) {
		return getMap (getMap (this.contents, key1), key2).get (key3);
	}

	static <L1,L2,U> WeakHashMap<L2,U> getMap (WeakHashMap<L1,WeakHashMap<L2,U>> map, L1 key) {
		WeakHashMap<L2,U> result = map.get (key);
		if (result == null) {
			result = new WeakHashMap<> ();
			map.put (key, result);
		}
		return result;
	}
}
