package hungerhelper.restaurants;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.fail;

import algs12.Point2D;
import org.junit.jupiter.api.Test;

class RestaurantTest {

    @Test
    void testGetters() {
        Restaurant r = new Restaurant("Buona Terra", Cuisine.Italian, new Point2D(0.4, 0.7));
        assertEquals("Buona Terra", r.getName());
        assertEquals(Cuisine.Italian, r.getCuisine());
        assertEquals(new Point2D(0.4, 0.7), r.getLocation());
    }

    @Test
    void testConstructorValidatesName() {
        try {
            Restaurant r = new Restaurant(null, Cuisine.Italian, new Point2D(0.4, 0.7));
            fail("Expected exception for null name");
        } catch(IllegalArgumentException ignored) {
        }
    }
}