package hungerhelper.restaurants;

import algs12.Point2D;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.HashSet;

import static org.junit.jupiter.api.Assertions.*;

class RestaurantsTest {

    private Restaurants restaurants;

    @BeforeEach
    void setup() {
        restaurants = new Restaurants();
    }

    @Test
    void testAddAndGet() throws Exception {
        Restaurant r1 = new Restaurant("Buona Terra", Cuisine.Italian, new Point2D(0.3, 0.4));
        restaurants.add(r1);
        Restaurant r2 = new Restaurant("Logan 11", Cuisine.American, new Point2D(0.15, 0.4));
        restaurants.add(r2);

        Restaurant r3 = restaurants.get(new RestaurantKey("Logan 11", new Point2D(0.15, 0.4)));
        assertEquals(r3, r2);
        assertNotEquals(r3, r1);
    }

    @Test
    void testGetNearby() {
        Restaurant r1 = new Restaurant("Buona Terra", Cuisine.Italian, new Point2D(0.1, 0.1));
        Restaurant r2 = new Restaurant("Logan 11", Cuisine.American, new Point2D(0.2, 0.2));
        Restaurant r3 = new Restaurant("SABA", Cuisine.Italian, new Point2D(0.3, 0.3));
        Restaurant r4 = new Restaurant("Taqueria Moran", Cuisine.Mexican, new Point2D(0.4, 0.4));
        Restaurant r5 = new Restaurant("Union", Cuisine.American, new Point2D(0.5, 0.5));

        restaurants.add(r1);
        restaurants.add(r2);
        restaurants.add(r3);
        restaurants.add(r4);
        restaurants.add(r5);

        ArrayList<Restaurant> nearMe = restaurants.getNearby(new Point2D(0.0,0.0), 3);
        assertEquals(3, nearMe.size());
        assertEquals(r1, nearMe.get(0));
        assertEquals(r2, nearMe.get(1));
        assertEquals(r3, nearMe.get(2));

    }
}
